/* pbcfg.c 1993.8.6 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <io.h>
#include <time.h>
#include <sys\stat.h>

#include "pbsv.h"

extern VOID ca2ad();		    /* pblib.c */

/* pbsv config data */

extern char cfgfile[];		    /* pbsv.c */
extern char bdcall[];
extern char bdadrs[];
extern int  port;
/* kiss mode parm */
extern int txd,persist,slottime,txtail;
extern int fullduplex,sethardware,softdcd;
extern char dldir[];
extern int  kissrom;
extern int multikiss;
extern BOOL f_debug,f_verbose,f_hex,f_headers;
extern BOOL f_etim;
extern clock_t tim_3;

#define EQ(A,B) (strcmp(A,B)==0)
/*
 * < svcfg > config
 */
int svcfg()
{
    FILE *fp;
    char buf[128];
    char *av1,*av2;

    printf("Reading configuration file <%s>.\n",cfgfile);
    if ((fp = fopen(cfgfile,"r")) == NULL) {
        printf("Error: configuration file not found.\n");
	exit(1);
    }
    while(fgets(buf,128,fp) != NULL) {
	strupr(buf);
	av1 = strtok(buf," \t\r\n");
	if (av1 == NULL)
	    continue;
        av2 = strtok(NULL," \t\r\n");
	if (av2 == NULL)
	    continue;
	if (EQ(av1,"BDCSTCALL")) {
	    strcpy(bdcall,av2);
	    ca2ad(bdcall,bdadrs);
	    printf("OK bdcstcall [%s]\n",bdcall);

	} else if (EQ(av1,"TXD")) {
            txd = atoi(av2);
	    printf("OK txd [%d]\n",txd);

	} else if (EQ(av1,"PERSIST")) {
            persist = atoi(av2);
	    printf("OK persist [%d]\n",persist);

	} else if (EQ(av1,"SLOTTIME")) {
            slottime = atoi(av2);
	    printf("OK slottime [%d]\n",slottime);

	} else if (EQ(av1,"TXTAIL")) {
            txtail = atoi(av2);
	    printf("OK txtail [%d]\n",txtail);

	} else if (EQ(av1,"FULLDUPLEX")) {
            fullduplex = atoi(av2);
	    printf("OK fullduplex [%d]\n",fullduplex);

	} else if (EQ(av1,"SETHARDWARE")) {
            sethardware = atoi(av2);
	    printf("OK sethardware [%d]\n",sethardware);

	} else if (EQ(av1,"SOFTDCD")) {
            softdcd = atoi(av2);
	    printf("OK softdcd [%d]\n",softdcd);

	} else if (EQ(av1,"DLDIR")) {
   	    strcpy(dldir,av2);
	    printf("OK dldir [%s]\n",dldir);

	} else if (EQ(av1,"KISSROM")) {
	    kissrom = atoi(av2);
	    printf("OK kissrom [%d]\n",kissrom);

        } else if (EQ(av1,"MULTIKISS")) {
	    multikiss = atoi(av2);
	    printf("OK multikiss [%d]\n",multikiss);

        } else if (EQ(av1,"PORT")) {
	    port = atoi(av2) - 1;
	    printf("OK port [%d]\n",port+1);

        } else if (EQ(av1,"DEBUG")) {
	    f_debug = atoi(av2);
	    printf("OK debug [%s]\n",f_debug ? "ON" : "OFF");

        } else if (EQ(av1,"VERBOSE")) {
	    f_verbose = atoi(av2);
	    printf("OK verbose [%s]\n",f_verbose ? "ON" : "OFF");

        } else if (EQ(av1,"HEX")) {
	    f_hex = atoi(av2);
	    printf("OK hex [%s]\n",f_hex ? "ON" : "OFF");

        } else if (EQ(av1,"HEADERS")) {
	    f_headers = atoi(av2);
	    printf("OK headers [%s]\n",f_headers ? "ON" : "OFF");

	} else {
	    ;
	}
    }
    fclose(fp);
}

/*
 * < dspinfo > display info.
 */
VOID dspinfo()
{
    printf("--- pbsv info ---\n");
    printf("pbsv.exe version %s %s\n",PBSV_VER,PBSV_ID);
    printf("port: COM%d\n",port+1);
    if (f_debug)
        printf("DEBUG ");
    if (f_verbose)
        printf("Verbose ");
    if (f_hex)
        printf("hex ");
    if (f_headers)
        printf("Headers ");
    printf("\n");
    printf("dldir: %s\n",dldir);
    printf("Bdcstcall: %s\n",bdcall);
    printf("txd: %dmsec. multikiss: %d\n",txd,multikiss);
    if (f_etim)
        printf("exit timer: %ld\n",(long)tim_3);
}

/* pbcfg.c */
